"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createDemoTabFileMeta = void 0;
const extractDemoTabFilePathInfo_1 = require("../02-extractDemoTabFilePathInfo/extractDemoTabFilePathInfo");
const findAssociateDemoTabFilesByName_1 = require("../03-findAssociateDemoTabFilesByName/findAssociateDemoTabFilesByName");
exports.createDemoTabFileMeta = (demoTabCodeFilePath, demoTabStyleFilePaths, prefix) => {
    const demoTabCodeFilePathInfo = extractDemoTabFilePathInfo_1.extractDemoTabFilePathInfo(demoTabCodeFilePath);
    const demoTabComponentFilename = `${prefix}${demoTabCodeFilePathInfo.filename.base}.${demoTabCodeFilePathInfo.filename.ext}`;
    const demoTabComponentName = `${prefix}${demoTabCodeFilePathInfo.filename.base}`;
    const demoTabComponentDestinationPath = `${demoTabCodeFilePathInfo.dirname}/${demoTabComponentFilename}`;
    const DemoTabFileMeta = {
        path: demoTabComponentDestinationPath,
        filename: demoTabComponentFilename,
        componentName: demoTabComponentName,
        code: {
            path: demoTabCodeFilePath,
            dirname: demoTabCodeFilePathInfo.dirname,
            filename: {
                base: demoTabCodeFilePathInfo.filename.base,
                ext: demoTabCodeFilePathInfo.filename.ext,
            },
        },
        style: { path: null, dirname: null, filename: { base: null, ext: null } },
    };
    const associateDemoTabStyleFilePaths = findAssociateDemoTabFilesByName_1.findAssociateDemoTabFilesByName(demoTabStyleFilePaths, DemoTabFileMeta.code.filename.base);
    if (associateDemoTabStyleFilePaths) {
        // per one code file only one style file is possible
        const demoTabStyleFilePathInfo = extractDemoTabFilePathInfo_1.extractDemoTabFilePathInfo(associateDemoTabStyleFilePaths[0]);
        DemoTabFileMeta.style.path = associateDemoTabStyleFilePaths[0];
        DemoTabFileMeta.style.dirname = demoTabStyleFilePathInfo.dirname;
        DemoTabFileMeta.style.filename.base = demoTabStyleFilePathInfo.filename.base;
        DemoTabFileMeta.style.filename.ext = demoTabStyleFilePathInfo.filename.ext;
    }
    return DemoTabFileMeta;
};
